// PrefixToPostfix.cpp

#include "Stack.h"
#include "postfix.h"

#include <iostream>
using namespace std;

bool isoperator(char op)
{
	switch(op)
	{
	case '+':
	case '-':
	case '*':
	case '/':
		return 1;
	default : 
		return 0;
	}
}


int priority(char op)
{
	switch(op)
	{
	case '#':
		return -1;
	case '(':
		return 0;
	case '+':
	case '-':
		return 1;
	case '*':
	case '/':
		return 2;
	default :
		return -1;
	}
}

//	 ׺ʽתΪ׺ʽغ׺ʽĳȣո
void postfix(char pre[] ,char post[],int &n)
{
	int i = 0 ,j=0;
	Stack<char> stack;

	stack.push('#');	// Ȱѽ־#ջ

	while(pre[i]!='#')
	{
		if((pre[i]>='0' && pre[i] <='9')||pre[i] =='.') // ֺСֱд׺ʽ
		{
			post[j++] = pre[i];
			n++;
		}
		else if (pre[i]=='(')	// ñȽֱջ
			stack.push(pre[i]);
		else if(pre[i] ==')')	// ŽӦźĲջеģȫд׺ʽ
		{
			while(stack.top()->data!='(')
			{
				post[j++] = stack.pop()->data;
				n++;
			}
			stack.pop(); // ջ׺ʽвС
		}
		else if (isoperator(pre[i]))
		{
			post[j++] = ' '; // ÿոֿ(
			n++;
			while(priority(pre[i]) <= priority(stack.top()->data)) 
			{
				// ǰĲСڵջȼʱջд뵽׺ʽظ˹
				post[j++] = stack.pop()->data;
				n++;
			}

			stack.push(pre[i]);	// ǰȼջȼòջ
		}

		i++;
	}
	while(stack.top() != NULL) // еĲ׺ʽ
	{
		post[j++] = stack.pop()->data;
		n++;
	}
}

double read_number(char str[],int *i)
{
	double x=0.0;
	int k = 0;
	while(str[*i] >='0' && str[*i]<='9')  // 
	{
		x = x*10+(str[*i]-'0');
		(*i)++;
	}

	if(str[*i]=='.') // С
	{
		(*i)++;
		while(str[*i] >= '0'&&str[*i] <='9')
		{
			x = x * 10 + (str[*i]-'0');
			(*i)++;
			k++;
		}
	}
	while(k!=0)
	{
		x /= 10.0;
		k--;
	}

	return x;
}

double postfix_value(char post[])
{
	Stack<double> stack;	// ջ

	int i=0 ;
	double x1,x2;

	while(post[i] !='#')
	{
		if(post[i] >='0' && post[i] <='9')
			stack.push(read_number(post,&i));
		else if(post[i] == ' ')
			i++;
		else if (post[i] =='+')
		{
			x2 = stack.pop()->data;
			x1 = stack.pop()->data;
			stack.push(x1+x2);
			i++;
		}
		else if (post[i] =='-')
		{
			x2 = stack.pop()->data;
			x1 = stack.pop()->data;
			stack.push(x1-x2);
			i++;
		}
		else if (post[i] =='*')
		{
			x2 = stack.pop()->data;
			x1 = stack.pop()->data;
			stack.push(x1*x2);
			i++;
		}
		else if (post[i] =='/')
		{
			x2 = stack.pop()->data;
			x1 = stack.pop()->data;
			stack.push(x1/x2);
			i++;
		}
	}
	return stack.top()->data;
}
